import { ResourceType } from "./resource-type";
export declare enum PointerType {
    EPHEMERAL = "EPHEMERAL",
    PERMANENT = "PERMANENT",
    ASSIGNABLE = "ASSIGNABLE"
}
export declare class ResourcePointer {
    datasetId: string;
    resourceType: ResourceType;
    pointerType: PointerType;
    id: string;
    constructor(datasetId?: string, resourceType?: ResourceType, pointerType?: PointerType, id?: string);
    get resourceShowId(): string;
    static assignablePtr(datasetId: string, resourceType: ResourceType, id: string): ResourcePointer;
    static permanentPtr(datasetId: string, resourceType: ResourceType, id: string): ResourcePointer;
    static equals(one: ResourcePointer, two: ResourcePointer): boolean;
    static listEquals(one: ResourcePointer[], two: ResourcePointer[]): boolean;
    static fromStringArr(arr: string[], defaultDatasetId?: string): ResourcePointer[];
    static fromString(s: string, defaultDatasetId?: string): ResourcePointer;
    static isValid(ptr: ResourcePointer): boolean;
    private static toResourceType;
    private static toPointerType;
    private static toPointerTypeCode;
    private static toResourceTypeCode;
    toString(defaultDatasetId?: string): string;
    toDisplayString(defaultDatasetId?: string): string;
    equals(that: ResourcePointer): boolean;
    isPermanentPtr(): boolean;
    isAssignablePtr(): boolean;
    isEphemeralPtr(): boolean;
}
